poj 1417

True Liars

Time Limit: 1000MS   Memory Limit: 10000K
Total Submissions: 2221   Accepted: 685

Description

After having drifted about in a small boat for a couple of days, Akira Crusoe Maeda was finally cast ashore on a foggy island. Though he was exhausted and despaired, he was still fortunate to remember a legend of the foggy island, which he had heard from patriarchs
in his childhood. This must be the island in the legend. In the legend, two tribes have inhabited the island, one is divine and the other is devilish, once members of the divine tribe bless you, your future is bright and promising, and your soul will eventually
go to Heaven, in contrast, once members of the devilish tribe curse you, your future is bleak and hopeless, and your soul will eventually fall down to Hell.

In order to prevent the worst-case scenario, Akira should distinguish the devilish from the divine. But how? They looked exactly alike and he could not distinguish one from the other solely by their appearances. He still had his last hope, however. The members
of the divine tribe are truth-tellers, that is, they always tell the truth and those of the devilish tribe are liars, that is, they always tell a lie.

He asked some of them whether or not some are divine. They knew one another very much and always responded to him "faithfully" according to their individual natures (i.e., they always tell the truth or always a lie). He did not dare to ask any other forms of
questions, since the legend says that a devilish member would curse a person forever when he did not like the question. He had another piece of useful informationf the legend tells the populations of both tribes. These numbers in the legend are trustworthy
since everyone living on this island is immortal and none have ever been born at least these millennia.

You are a good computer programmer and so requested to help Akira by writing a program that classifies the inhabitants according to their answers to his inquiries.

Input

The input consists of multiple data sets, each in the following format :

n p1 p2

xl yl a1

x2 y2 a2

...

xi yi ai

...

xn yn an

The first line has three non-negative integers n, p1, and p2. n is the number of questions Akira asked. pl and p2 are the populations of the divine and devilish tribes, respectively, in the legend. Each of the following n lines has two integers xi, yi and one
word ai. xi and yi are the identification numbers of inhabitants, each of which is between 1 and p1 + p2, inclusive. ai is either yes, if the inhabitant xi said that the inhabitant yi was a member of the divine tribe, or no, otherwise. Note that xi and yi
can be the same number since "are you a member of the divine tribe?" is a valid question. Note also that two lines may have the same x‘s and y‘s since Akira was very upset and might have asked the same question to the same one more than once.

You may assume that n is less than 1000 and that p1 and p2 are less than 300. A line with three zeros, i.e., 0 0 0, represents the end of the input. You can assume that each data set is consistent and no contradictory answers are included.

Output

For each data set, if it includes sufficient information to classify all the inhabitants, print the identification numbers of all the divine ones in ascending order, one in a line. In addition, following the output numbers, print end in a line. Otherwise, i.e.,
if a given data set does not include sufficient information to identify all the divine members, print no in a line.

Sample Input

2 1 1
1 2 no
2 1 no
3 2 1
1 1 yes
2 2 yes
3 3 yes
2 2 1
1 2 yes
2 3 no
5 4 3
1 2 yes
1 3 no
4 5 yes
5 6 yes
6 7 no
0 0 0

Sample Output

no
no
1
2
end
3
4
5
6
end
分析:题意:在一个孤岛上有两个部落,一个部落都是好人,一个部落都是坏人,好人都说真话,坏人
都说假话。有一群人来自两个部落,通过给定的数据确定那些是好人,且以升序输出。
这道题有一点需要注意:好人说真话,如果一个人是好人,他说另一个人是坏人这这个人一定是坏人,否则
这个人一定是好人;相反,如果一个人是坏人,他说另一个人是坏人则这个人一定是好人,否则这个人一定
是坏人。另外要记住在这里面好人坏人是相对的,也就是说我们只能判断谁和谁同等人,即yes带表同等集合
no表示相反集合。
这道题我们要最终把这一群人分成若干集合(一颗树就是一个集合,一群人是一个森林),然后每一个集合分成
朋友,敌人两个子集a和b(大家不要误解朋友集合和敌人集合的意思,它们是通过并查集确定的两个集合,在这两个集合中
必有一个集合为好人,一个集合为坏人,只不过我们现在还不确定是好谁坏)。这个用并查集可以不难做到。难点是一下:
因为题目已经告诉好人坏人的个数,因此我们从这若干个集合中每个集合挑出一个子集,是这些子集之和等于好人
数目p1,判断这样的情况有多少种,如果答案唯一则可以确定那些事好人,那些是坏人了,因此需要用
到动态规划中的背包一类。
设数组dp【maxn】【maxn】,dp【i】【j】代表到第i个集合好人数为j的情况数; 状态转移方程为:
dp【i】【j】=dp【i-1】【j-a】+dp【i-1】【j-a】;
如果dp【cnt】【p1】==1说明情况唯一(cnt为集合数),则可一找出好人个数;
由于小生是dp学的不好所以猥琐看了某君dp代码,其中有一句:点dp【i】【j】>1时我都是dp【i】【j】=2;
以为算到最后如果dp【cnt】【p1】>1就无解,所以dp【i】【j】>1就行。
唉,必须好好学啊,加油。
献上代码:
#include<stdio.h>
#include<string.h>
#include<algorithm>
#include<iostream>
using namespace std;
const int maxn=600+10;
int fa[maxn],level[maxn],id[maxn];
int dp[maxn][maxn],ans[maxn][maxn],map[maxn][2],num[maxn][2];
void Init(int snum)
{
    for(int i=0;i<=snum;i++)
    {
        fa[i]=i;
    }
    memset(dp,0,sizeof(dp));
    memset(level,0,sizeof(level));
    memset(ans,0,sizeof(ans));
    memset(map,0,sizeof(map));
    memset(num,0,sizeof(num));
    memset(id,0,sizeof(id));
}
int find(int x)
{
    if(x!=fa[x])
    {
        int tmp=fa[x];
        fa[x]=find(fa[x]);
        level[x]=level[x]^level[tmp];
    }
    return fa[x];
}
int main()
{
    int n,p1,p2,x,y,fx,fy,cnt;
    char c[10];
    while(~scanf("%d%d%d",&n,&p1,&p2)&&(n+p1+p2))
    {
        Init(p1+p2);
        for(int i=0;i<n;i++)
        {
            scanf("%d%d%s",&x,&y,c);
            fx=find(x);
            fy=find(y);
            if(fx==fy)
            continue;
            fa[fy]=fx;
            if(c[0]==‘y‘)
            {
                level[fy]=level[x]^level[y]^0;
            }
            else
            {
                level[fy]=level[x]^level[y]^1;
            }
        }
        cnt=0;
        for(int i=1;i<=p1+p2;i++)
        if(find(i)==i)id[i]=++cnt;
        for(int i=1;i<=p1+p2;i++)
        {
            map[id[find(i)]][level[i]]++;
        }
        dp[0][0]=1;
        for(int i=1;i<=cnt;i++)
        for(int j=0;j<=p1+p2;j++)
        {   
            if(j>=map[i][0]&&dp[i-1][j-map[i][0]]>0)
            {   
                dp[i][j]+=dp[i-1][j-map[i][0]];
                ans[i][j]=map[i][0];
            }
            if(j>=map[i][1]&&dp[i-1][j-map[i][1]]>0)
            {   
                dp[i][j]+=dp[i-1][j-map[i][1]];
                ans[i][j]=map[i][1];
            }
            if(dp[i][j]>1)
            dp[i][j]=2;
        }
        if(dp[cnt][p1]!=1)
        {
            printf("no\n");
            continue;
        }
        for(int i=cnt,j=p1;i>=1;i--)
        {
            if(map[i][0]==ans[i][j])num[i][0]=1;
            else num[i][1]=1;
            j-=ans[i][j];
        }
        for(int i=1;i<=p1+p2;i++)
        {
            if(num[id[find(i)]][level[i]])
            printf("%d\n",i);
        }
        printf("end\n");
    }
    return 0;
}
        
                
        
        
            
                
                
            
            
				
时间: 2024-07-31 19:47:24

poj 1417的相关文章

poj 1417 并查集+dp

转自:点我 题目:给出p1+p2个人,其中p1个是好人,p2个是坏人.然后有一些关系 ,a说b是好人(坏人).其中没有矛盾的,判断是否有唯一解判断哪些人是好人,哪些人是坏人. 其中比较重要的是,好人总说真话,坏人总说假话.不需要判断矛盾.唯一解 http://poj.org/problem?id=1417 其中好人说真话,坏人说假话这点很重要. 那么如果一个人说另一个人是好人,那么如果这个人是好人,说明 对方确实是好人,如果这个是坏人,说明这句话是假的,对方也是坏人. 如果一个人说另一个人是坏人

POJ 1417 True Liars 并查集+背包

题目链接:http://poj.org/problem?id=1417 解题思路:比较容易想到的是并查集,然后把第三组数据测试一下之后发现这并不是简单的并查集,而是需要合并之后然后判断的.并且鉴于题目要求输出数据,因此还要记录数据,可以说是非常有意思的题目. 首先,如果a b yes,那么a与b一定都是圣人或者恶人:反之,如果a b no,那么两者一个圣人,一个恶人.因此可以将所有元素分为若干个集合,每个集合中放两个小集合,表示两种不一样的人,当然并不知道到底哪个里面是圣人,恶人. 另一个比较棘

POJ 1417 True Liars

POJ连炸多日-- 1.发现a,b相同会回答yes 否则回答no 2.套用并查集模板 画图 设边权:相同为0,不同为1 猜\(fav[fa1]=fav[a] \) xor \( fav[b] \;\) xor \( d\),枚举各种情况果然成立-- 3.得到一棵树 其实中途会进行路径压缩-- 可以统计每棵树中与代表元素相同的个数(A[i])和不同的个数(B[i])(边权为1说明不同,为0说明相同) 然后问题就转换成 \(n = 树的棵数\) \(X[i] = A[i]\;\;\;or\;\;\;

POJ 1417 True Liars(并查集+DP)

大意: 一个岛上有神与恶魔两个种族,神会说真话,恶魔会说假话.已知神与恶魔的个数,但不知道具体个人是属于哪个. n,x,y 这个人问n次 ,x为神的个数,y为恶魔的个数. 每次的问题为 xi,yi,a 问xi ,yi是否为神? a为yes/no.注意xi,yi可能为同一个人 若最终可得出哪些是神则从小到大输出神的编号,并最终输出end 否则输出no 思路: 经过简单推理可得,只要是说yes,xi,yi为同一个族,no则不为同一个族. 这样通过使用并查集+relation(relation[i]为

*并查集的题*

POJ 1182 食物链http://acm.pku.edu.cn/JudgeOnline/problem?id=1182题目告诉有3种动物,互相吃与被吃,现在告诉你m句话,其中有真有假,叫你判断假的个数(如果前面没有与当前话冲突的,即认为其为真话)这题有几种做法,我以前的做法是每个集合(或者称为子树,说集合的编号相当于子树的根结点,一个概念)中的元素都各自分为A, B, C三类,在合并时更改根结点的种类,其他点相应更改偏移量.但这种方法公式很难推,特别是偏移量很容易计算错误.下面来介绍一种通用

跟着chengyulala刷题之[kuangbin带你飞]之&#39;并查集&#39;专题/斜眼笑

[kuangbin带你飞] 专题1-23 https://vjudge.net/article/187 专题五 并查集 POJ 2236 Wireless Network  http://poj.org/problem?id=2236POJ 1611 The Suspects  http://poj.org/problem?id=1611HDU 1213 How Many Tables  http://acm.hdu.edu.cn/showproblem.php?pid=1213HDU 3038

POJ - 3186 Treats for the Cows (区间DP)

题目链接:http://poj.org/problem?id=3186 题意:给定一组序列,取n次,每次可以取序列最前面的数或最后面的数,第n次出来就乘n,然后求和的最大值. 题解:用dp[i][j]表示i~j区间和的最大值,然后根据这个状态可以从删前和删后转移过来,推出状态转移方程: dp[i][j]=max(dp[i+1][j]+value[i]*k,dp[i][j-1]+value[j]*k) 1 #include <iostream> 2 #include <algorithm&

POJ 2533 - Longest Ordered Subsequence(最长上升子序列) 题解

此文为博主原创题解,转载时请通知博主,并把原文链接放在正文醒目位置. 题目链接:http://poj.org/problem?id=2533 Description A numeric sequence of ai is ordered if a1 < a2 < ... < aN. Let the subsequence of the given numeric sequence (a1, a2, ..., aN) be any sequence (ai1, ai2, ..., aiK)

POJ——T2271 Guardian of Decency

http://poj.org/problem?id=2771 Time Limit: 3000MS   Memory Limit: 65536K Total Submissions: 5932   Accepted: 2463 Description Frank N. Stein is a very conservative high-school teacher. He wants to take some of his students on an excursion, but he is